;;; scsh-specific.scm
;;; Mike Wilson
;;; March 22, 1999

;; (define upcase-symbol
;;   (lambda (sym)
;;     (let* ((sym-str (symbol->string sym))
;; 	      (str-len (string-length sym-str)))
;; 	 (string->symbol (string-map char-upcase sym-str)))))
;; 
;; (define capitalize-symbol
;;   (lambda (sym)
;;     (let ((str (copy-string (symbol->string sym))))
;; 	 (if (> (string-length str) 0)
;; 	   (string-set! str 0 (char-upcase (string-ref str 0))))
;; 	 str)))

(define null-char (ascii->char 0))

(define binary-string->printable-string
  (lambda (str)
    (let ((char->printable-string
	   (lambda (char)
	     (let ((num (number->string (char->ascii char))))
	       (if (or (char-alphabetic? char)
		       (char-numeric? char)
		       (member char '(#\, #\. #\: #\; #\! #\space)))
		   (format #f "<~a/~a>" char num)
		   (format #f "<~a>" num))))))
      (apply string-append
	     (map char->printable-string
		  (string->list str))))))


;;; (string->binary (number->card8 2))  => "10"

(define string->binary
  (lambda (str)
    (apply string-append
	   (map (lambda (c)
		  (number->string (char->ascii c) 2))
		(string->list str)))))
